View Javadoc

    1   /**
    2    * Licensed to the Apache Software Foundation (ASF) under one
    3    * or more contributor license agreements.  See the NOTICE file
    4    * distributed with this work for additional information
    5    * regarding copyright ownership.  The ASF licenses this file
    6    * to you under the Apache License, Version 2.0 (the
    7    * "License"); you may not use this file except in compliance
    8    * with the License.  You may obtain a copy of the License at
    9    *
    10   *   http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   * Unless required by applicable law or agreed to in writing,
    13   * software distributed under the License is distributed on an
    14   * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   * KIND, either express or implied.  See the License for the
    16   * specific language governing permissions and limitations
    17   * under the License.
    18   */
    19  package org.apache.mina.api;
    20
    21  import java.util.concurrent.Future;
    22
    23  /**
    24   * A simple extension that allows listeners to register and receive results
    25   * asynchronously via registered listeners.  The listeners will be called from
    26   * an event pool and so any amount of significant work should not be done in
    27   * this listener.
    28   *
    29   * @author <a href="http://mina.apache.org">Apache MINA Project</a>
    30   */
    31  public interface IoFuture<V> extends Future<V> {
    32      /**
    33       * Register a listener to asynchronously receive the results of the
    34       * future computation.
    35       *
    36       * @param listener the listener to asynchronously receive the results of the future computation
    37       * @return the instance of the future to allow "chaining" of registrations
    38       */
    39      IoFuture<V> register(IoFutureListener<V> listener);
    40  }